﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace hotan
{
    public partial class Form1 : Form
    {
        //A fal kirajzolásához használt toll
        private Pen falToll = new Pen(Color.Brown, 3);
        //A molekulák kirajzolásához használt ecset
        private SolidBrush molekulaEcset = new SolidBrush(Color.Blue);
        //Ez egy Molekula osztálokból (ld.lent) álló lista
        //Itt tárolom a molekulák adatait
        private List<Molekula> molekulak = new List<Molekula>();

        public Form1()
        {//Ugye az a függvény fut elinduláskor
            InitializeComponent();
            //létrehozok veletlen néven egy véletlenszám generátort
            Random veletlen = new Random();
            //a 100 molekulát létrehozó ciklus
            for (int i = 0; i < 100; i++)
            {
                //létrehozom a Molekula osztály 1 példányát
                Molekula molekula = new Molekula();
                //beállitom az értékeket
                //X,Y a bal oldali félen valahol
                molekula.hely.X = veletlen.Next(5, ClientRectangle.Width / 2 - 5);
                molekula.hely.Y = veletlen.Next(5, ClientRectangle.Height - 5);
                //mérete 5*5
                molekula.hely.Width = 5;
                molekula.hely.Height = 5;
                //a sebessége -10 és 10 között változik
                molekula.xSeb = veletlen.Next(-10,11);
                molekula.ySeb = veletlen.Next(-10,11);
                //hozzáadom a listához
                molekulak.Add(molekula);
            }
            //megvan a 100 molekulából álló lista
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {//ez fut le ha újra kell rajzolni az ablakot
            //felző kiszámítása
            int felezoX = ClientRectangle.Width / 2;
            //ajtó szélessége
            int ajto = ClientRectangle.Height
                * Convert.ToInt32(numericUpDownAjto.Value) / 100;
            //ajtó teteje és alja
            int ajtoTeto = (ClientRectangle.Height - ajto) / 2;
            int ajtoAlja = (ClientRectangle.Height + ajto) / 2;
            //ajtó feletti fal
            e.Graphics.DrawLine(falToll, felezoX, 0, felezoX, ajtoTeto);
            //ajtó, ha kell
            if (!checkBoxAjto.Checked)
            {
                e.Graphics.DrawLine(falToll, felezoX, ajtoTeto, felezoX, ajtoAlja);
            }
            //ajtó altti fal
            e.Graphics.DrawLine(falToll, felezoX, ajtoAlja, felezoX, ClientRectangle.Height);
            //végigmegyek az össes molekulán
            foreach (Molekula molekula in molekulak)
            {//a molekula az egyes példány
                e.Graphics.FillEllipse(molekulaEcset, molekula.hely);
            }
        }

        private void checkBoxAjto_CheckedChanged(object sender, EventArgs e)
        {//változik az ajtó nyitottsága
            Invalidate();
            Update();
        }

        private void numericUpDownAjto_ValueChanged(object sender, EventArgs e)
        {//változik az ajó szélessége
            Invalidate();
            Update();
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {// változik az ablak mérete
            Invalidate();
            Update();
        }

        private void timerIdoalap_Tick(object sender, EventArgs e)
        {// lejár a timer (100 ms-onként egyszer fut le)
            //felező és ajtó paraméterel ld.: Form1_Paint
            int felezoX = ClientRectangle.Width / 2;
            int ajto = ClientRectangle.Height
                * Convert.ToInt32(numericUpDownAjto.Value) / 100;
            int ajtoTeto = (ClientRectangle.Height - ajto) / 2;
            int ajtoAlja = (ClientRectangle.Height + ajto) / 2;
            //minden molekula új pozícióját külön-külön ki kell számolni
            foreach (Molekula molekula in molekulak)
            {
                //őj X és Y koordináta kiszámítása
                int ujX = molekula.hely.X + molekula.xSeb;
                int ujY = molekula.hely.Y + molekula.ySeb;
                //ütközések figyelése
                if (ujX <= 0)
                {//bal oldalfal
                    molekula.xSeb = 0 - molekula.xSeb;
                    ujX = molekula.hely.X;
                }
                if (ujX >= ClientRectangle.Width)
                {//jobb oldalfal
                    molekula.xSeb = 0 - molekula.xSeb;
                    // ez az if azért kell, hogy a méretváltoztatás miatt kintrekedtek "visszakerüljenek"
                    if (molekula.hely.X < ClientRectangle.Width)
                    {
                        ujX = molekula.hely.X;
                    }
                    else
                    {
                        ujX = ClientRectangle.Width;
                    }
                    ujX = molekula.hely.X;
                }
                if (ujY <= 0)
                {//teteje
                    molekula.ySeb = 0 - molekula.ySeb;
                    ujY = molekula.hely.Y;
                }
                if (ujY >= ClientRectangle.Height)
                {//alja
                    molekula.ySeb = 0 - molekula.ySeb;
                    // ez az if azért kell, hogy a méretváltoztatás miatt kintrekedtek "visszakerüljenek"
                    if (molekula.hely.Y < ClientRectangle.Height)
                    {
                        ujY = molekula.hely.Y;
                    }
                    else
                    {
                        ujY = ClientRectangle.Height;
                    }
                }
                //ütközés a falnál
                if (((ujX <= felezoX) && (molekula.hely.X > felezoX))
                    || ((ujX > felezoX) && (molekula.hely.X <= felezoX)))
                {//fal átlépés, ha a régi nem azon az oldalon van mint az új
                    if ((!checkBoxAjto.Checked)
                        || (molekula.hely.Y < ajtoTeto)
                        || (molekula.hely.Y > ajtoAlja))
                    {//nem az ajtónál vagy csukva van az ajtó
                        ujX = molekula.hely.X;
                        molekula.xSeb = 0 - molekula.xSeb;
                    }
                }
                //az ütközéssel számolt új helyre teszem a molekulát
                molekula.hely.X = ujX;
                molekula.hely.Y = ujY;
            }
            Invalidate();
            Update();
        }
    }

    //A MOLEKULÁKAT LEÍRÓ OSZTÁLY
    public class Molekula
    {
        //hol van
        public Rectangle hely;
        //X irányú sebesség
        public int xSeb;
        //Y irányú sebesség
        public int ySeb;
    }
}
